import { defineStore } from "pinia";
import CryptoJS from "crypto-js";

// 登录
export const FormLoginUser = defineStore({
  id: "FormLoginUser",
  state: () => ({
    encryptedUsername: "",
    encryptedPassword: "",
    SECRET_KEY: "your-secret-key",
  }),
  getters: {
    // 使用 RC4 加密
  },
  actions: {
    // 登录时加密并保存
    loginYester(data) {
      const encryptedData = this.encryptData(data);
      localStorage.setItem("USER_KEY_ACCOUT", encryptedData);
    },

    // 加载加密后的账户信息
    loadCredentials() {
        const encryptedData = localStorage.getItem("USER_KEY_ACCOUT") || false;
      if (encryptedData) {
        return this.decryptData(encryptedData);
      }
      return null;
    },
    encryptData(data) {
      const jsonString = JSON.stringify(data);
      // 使用 RC4 加密
      return CryptoJS.RC4.encrypt(jsonString, this.SECRET_KEY).toString();
    },
    // 解密数据
    decryptData(encryptedData) {
      // 解密 RC4 数据
      const bytes = CryptoJS.RC4.decrypt(encryptedData, this.SECRET_KEY);
      // 将解密后的结果转换为字符串并解析为对象
      const decryptedData = bytes.toString(CryptoJS.enc.Utf8);
      return JSON.parse(decryptedData); // 解析为对象
    },
  },
});
